import matplotlib.pyplot as plt
import numpy as np

def averageCurrent(minutes, sending):
    tnotif = minutes*60.0
    totalTime = 168.2 + 268 + 38.6 #time used regardless of sending
    totalCurrent = 22.1 + 21 + 13.3 #current used regardless of sending
    if(sending):
        totalTime += 2646.7 #added time for sending
        totalCurrent += 236.7 #added current for sending

    totalTime += (tnotif-totalTime) #add deep sleep time
    sleepCurrent = 0.045 * (tnotif-totalTime) #45 microAmpere
    totalCurrent += sleepCurrent #add deep sleep current
    totalTime = totalTime * 0.001 #normalize time to seconds
    totalpower = totalTime*totalCurrent
    Iavg = totalpower/tnotif #calculate the average current
    
    return Iavg

def getDeviceLifeTimeWhenReducingPercentageOfSentPackets():
    Results = [0.0]*101 #list of length 100

    for i in range(0, 101):
        percentageSent = (100-i)*0.01 #percentage of sent packets
        percentageNotSent = i*0.01 #percentage of sent packets
        notificationPeriod = 1.0
        Results[i] += averageCurrent(notificationPeriod,True)*percentageSent
        Results[i] += averageCurrent(notificationPeriod, False)*percentageNotSent

    batteryCapacity = 4800 #mah
    lifetime = np.array([(batteryCapacity / avgcurrent)/24 for avgcurrent in Results])
    return lifetime


percentageNotSent = np.array(range(0,101)) #list of values between 0 and 100
lifetime = getDeviceLifeTimeWhenReducingPercentageOfSentPackets()
print(lifetime[0],lifetime[49])
plt.plot(percentageNotSent,lifetime)
plt.title('Battery lifetime when reducing amount of sent packets for 10 min duty cycle\n')
plt.xlabel('Percentage of packets not sent\n')
plt.ylabel('Battery lifetime (days)\n')
plt.show()


