import machine, time, pycom, socket, struct
from network import LoRa

DEVICE_ID = 1
initial_format = b'b'

# Open a Lora Socket, use tx_iq to avoid listening to our own messages
lora = LoRa(mode=LoRa.LORA, rx_iq=True)
lora_sock = socket.socket(socket.AF_LORA, socket.SOCK_RAW)
lora_sock.setblocking(False)

def recv_packet():
    received_packet = ""
    while True:
        recv_packet = lora_sock.recv(1024)
        if (len(recv_packet) > 0):
            packet_format = initial_format.decode('utf-8') + '%ss' % (len(recv_packet)-(len(initial_format)),)
            device_id, message = struct.unpack(packet_format, recv_packet)
            message = message.decode('utf-8')
            if (int(device_id) == DEVICE_ID):
                if (message == "sending done"):
                    return received_packet
                else:
                    if (message.split("=")[0] != "id"):
                        received_packet += str(message)
                    
        time.sleep(1)

while(True):
    packet = recv_packet()
    exec(packet)