from energyTest import Program
from network import LoRa
from machine import Pin
import time

if __name__ == '__main__':
    if (machine.reset_cause() == machine.DEEPSLEEP_RESET):
        p_one = Pin('P21', mode=Pin.OUT)
        p_one.value(0)
        time.sleep(1)
        p_one.value(1)
        print("Reset from deep sleep")
        firstRun = False
        p = Program(firstRun)
        lora = LoRa(mode=LoRa.LORAWAN, region=LoRa.EU868)
        lora.nvram_restore()
        p.reInit(lora)
        p.run()
    else:
        p_one = Pin('P21', mode=Pin.OUT)
        p_one.value(0)
        print("Program started for the first time")
        firstRun = True
        wlan = network.WLAN()
        wlan.deinit()
        server = network.Server()
        server.deinit()
        bluetooth = network.Bluetooth()
        bluetooth.deinit()
        lte = network.LTE()
        lte.deinit()
        p = Program(firstRun)
        p.initLora()
        p.run()