import socket, os
import time
import binascii
import struct
import pycom
#from nodeLib import *
import network
from network import LoRa
from machine import Timer, Pin

print('Switching off Heartbeat')
pycom.heartbeat(False)
pycom.rgbled(0x000022)
pycom.wifi_on_boot(False)


print('Switching off WLAN')
wlan = network.WLAN()
wlan.deinit()

print('Switching off Server')
server = network.Server()
server.deinit()

print('Switching off Bluetooth')
bt = network.Bluetooth()
bt.deinit()

print('Switching off LTE')
lte = network.LTE()
lte.deinit()

print('Switching off RGB Led')
pycom.rgbled(0x000000)

p_one = Pin('P21', mode=Pin.OUT)
p_two = Pin('P22', mode=Pin.OUT)
p_three = Pin('P23', mode=Pin.OUT)
p_four = Pin('P8', mode=Pin.OUT)
p_one.value(1)
p_two.value(0)
p_three.value(0)
p_four.value(0)

lora = LoRa(mode=LoRa.LORAWAN, region=LoRa.EU868)
print("Initializing LoRa")
dev_eui = binascii.unhexlify('0123456789ABCDEF')
app_eui = binascii.unhexlify('0000000000000001')
app_key = binascii.unhexlify('0123456789ABCDEF0123456789ABCDEF')

# set the 3 default channels to the same frequency (must be before sending the OTAA join request)
lora.add_channel(0, frequency=868100000, dr_min=0, dr_max=5)
lora.add_channel(1, frequency=868100000, dr_min=0, dr_max=5)
lora.add_channel(2, frequency=868100000, dr_min=0, dr_max=5)

lora.join(activation=LoRa.OTAA, auth=(dev_eui, app_eui, app_key), timeout=0, dr=5)
# wait until the module has joined the network
count = 0
print("Joining network...")
while not lora.has_joined():
    pycom.rgbled(0xff0000)
    time.sleep(2.5)
    pycom.rgbled(0x000000)
    print("Not yet joined count is:" ,  count)
    count = count + 1

print("Network joined!")
# remove all the non-default channels
for i in range(3, 16):
    lora.remove_channel(i)

# create a LoRa socket
s = socket.socket(socket.AF_LORA, socket.SOCK_RAW)

# set the LoRaWAN data rate
s.setsockopt(socket.SOL_LORA, socket.SO_DR, 5)

def blinkLight():
    pycom.rgbled(0x00FF00)
    time.sleep(1)
    pycom.rgbled(0x000000)
    time.sleep(1)
    pycom.rgbled(0x00FF00)
    time.sleep(1)
    pycom.rgbled(0x000000)
    time.sleep(1)

# def recvFromServer():
#     s1 = makeSocket(False)
#     rx, port = s1.recvfrom(256)
#     return rx, port


blinkLight()
bytesToSend = [1,4,8,16,32,64,90,128,192,222]
for i in range(0, len(bytesToSend)):
    toSend = "A"*64
    print("Sending {0}".format(toSend))
    p_two.value(1)
    time.sleep(1)
    for x in range(0,1000):
        s.setblocking(True)
        s.send(toSend)
        s.setblocking(False)
        time.sleep(1)
        p_three.value(1)
        rx, port = s.recvfrom(256)
        if (rx):
            #print("received")
            p_four.value(1) #if data was received. Notify Lopy.
        time.sleep(0.1)
        #print("Data: {0}, on port {1}".format(dataDown, port))
        p_three.value(0)
        time.sleep(4)
        p_four.value(0)
    p_two.value(0)
    time.sleep(1)
p_one.value(0)

